<cfprocessingdirective suppresswhitespace="Yes">
<!---+---------------------------------------------------------+
copyright 2002 Morgan Kelsey, all rights reserved. You may reuse 
and modify this code, as long as this copyright is present.

this template requires a database to hold the gallery pictures

Author: Morgan Kelsey
morgan@morgankelsey.com

Created: 1/03/02
+--------------------------------------------------------------+--->
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd">
<html>
<head>
  <title>Rotating Gallery</title>
  <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-1">
</head>

<body>

<cfquery name="qGallery" datasource="rotating_gallery" cachedwithin="#CreateTimeSpan(0, 0, 10, 0)#">
  SELECT ID
       , img_thumb
       , img_width
       , img_height
       , img_title
    FROM gallery
   ORDER BY ID;
</cfquery>  

<!--- initialize variables --->
<cfset start_day = DateDiff("y", "01/01/2000", Now())>
<cfset total_items = 12><!--- total items to display --->
<cfset start_item = (start_day MOD qGallery.recordcount) + 1>
<cfset end_item = start_item + (total_items - 1)>
<cfset columns = 4>
<cfset col_tick = 0>
<cfset count = 0>

<cfif end_item GT qGallery.recordcount>
  <cfset end_item = end_item - qGallery.recordcount>
</cfif>


<div align="center">
<table width="70%" border="0" cellpadding="4" cellspacing="0"> 
<tr>

<cfoutput>
  <cfif start_item LT end_item><!--- we can do it one loop, the end_item is higher than the start_item --->

    <cfloop query="qGallery" startrow="#start_item#" endrow="#end_item#">
      <cfset col_tick = IncrementValue(col_tick)>
      <cfset count = IncrementValue(count)>
      <td width="40"><img src="#img_thumb#" height="#img_height#" width="#img_width#" alt="#img_title#"></td>
      <cfif count EQ total_items>
        </tr></table>
      <cfelseif col_tick EQ columns>
        </tr><tr><cfset col_tick = 0>
      </cfif>
    </cfloop>
  
  <cfelse><!--- start_item NOT LT end_item - we need two loops - 1st to the end of the recodset, 2nd to the end_item value --->

    <cfloop query="qGallery" startrow="#start_item#" endrow="#qGallery.recordcount#">
      <cfset col_tick = IncrementValue(col_tick)>
      <cfset count = IncrementValue(count)>
      <td width="40"><img src="#img_thumb#" height="#img_height#" width="#img_width#" alt="#img_title#"></td>
        <cfif col_tick EQ columns>
          </tr><tr><cfset col_tick = 0>
        </cfif>
    </cfloop>

    <cfloop query="qGallery" startrow="1" endrow="#end_item#">
      <cfset col_tick = IncrementValue(col_tick)>
      <cfset count = IncrementValue(count)>
      <td width="40"><img src="#img_thumb#" height="#img_height#" width="#img_width#" alt="#img_title#"></td>
      <cfif count EQ total_items>
        </tr></table>
      <cfelseif col_tick EQ columns>
        </tr><tr><cfset col_tick = 0>
      </cfif>
    </cfloop>

  </cfif><!--- close if start_item LT end_item --->

</cfoutput>

</div>

</body>
</html>
</cfprocessingdirective>

